org.eclipse.cdt.core

## Interface ICExtensionReference

Deprecated.
replaced with `ICConfigExtensionReference` obtained from an `ICConfigurationDescription`

    @Deprecated
    public interface ICExtensionReference

This is reference to `ICExtension` elements as stored in the Project Description. This has no notion of the ICConfigurationDescription, for that see `ICConfigExtensionReference`

See Also:
  `ICConfigExtensionReference`, `ICExtension`, `ICDescriptor`
Restriction:
  This interface is not intended to be referenced by clients.

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`ICExtension` `createExtension()` Deprecated. Creates and returns a new instance of the cextension executable identified by the <run> attribute of the cextension.
`ICDescriptor` `getCDescriptor()` Deprecated. Returns the project descriptor which this extension reference belongs to.
`String` `getExtension()` Deprecated. Return the extension point of this reference.
`String` `getExtensionData(String key)` Deprecated. Gets a value of the key from the .cdtproject file set by setExtensionData()
`org.eclipse.core.runtime.IConfigurationElement[]` `getExtensionElements()` Deprecated. Returns all configuration elements that are children of the cextension element.
`String` `getID()` Deprecated. Return the extension ID of this reference.
`void` `setExtensionData(String key, String value)` Deprecated. Sets a name/value data pair on this reference in the .cdtproject file

### Method Detail

#### getExtension

    String getExtension()

Deprecated.
Return the extension point of this reference.

Returns:
  String

#### getID

    String getID()

Deprecated.
Return the extension ID of this reference.

Returns:
  String

#### setExtensionData

    void setExtensionData(String key,
                          String value)
                   throws org.eclipse.core.runtime.CoreException

Deprecated.
Sets a name/value data pair on this reference in the .cdtproject file

Throws:
  `org.eclipse.core.runtime.CoreException`

#### getExtensionData

    String getExtensionData(String key)

Deprecated.
Gets a value of the key from the .cdtproject file set by setExtensionData()

#### getCDescriptor

    ICDescriptor getCDescriptor()

Deprecated.
Returns the project descriptor which this extension reference belongs to.

Returns:
  the ICDescriptor

#### createExtension

    ICExtension createExtension()
                         throws org.eclipse.core.runtime.CoreException

Deprecated.
Creates and returns a new instance of the cextension executable identified by the <run> attribute of the cextension.

The ICExtension is instantiated using its 0-argument public constructor. If the class implements the `org.eclipse.core.runtime.IExecutableExtension` interface, the method `setInitializationData` is called, passing to the object the configuration information that was used to create it.

Unlike other methods on this object, invoking this method may activate the plug-in.

Returns:
  the executable ICExtension instance
Throws:
  `org.eclipse.core.runtime.CoreException` - if an instance of the executable extension could not be created for any reason.
See Also:
  `IExecutableExtension.setInitializationData(org.eclipse.core.runtime.IConfigurationElement, java.lang.String, java.lang.Object)`

#### getExtensionElements

    org.eclipse.core.runtime.IConfigurationElement[] getExtensionElements()
                                                                   throws org.eclipse.core.runtime.CoreException

Deprecated.
Returns all configuration elements that are children of the cextension element. Returns an empty array if this configuration element has no children.

Each child corresponds to a nested XML element in the configuration markup. For example, the configuration markup

      <view>
          <verticalHint>top</verticalHint>
          <horizontalHint>left</horizontalHint>
      </view>

corresponds to a configuration element, named `"view"`, with two children.

Returns:
  the child configuration elements
Throws:
  `org.eclipse.core.runtime.CoreException`